-----------------------------------------------------------------------------------------------
-- Client Lua Script for AugmentorsHelper
-- Copyright (c) NCsoft. All rights reserved
-- Some code/ideas was taken from Maat's OhmnaKnockbackAssist addon
-- 
-------------------------------------------------------------------------------------------
 
require "Window"
 
-----------------------------------------------------------------------------------------------
-- AugmentorsHelper Module Definition
-----------------------------------------------------------------------------------------------
local AugmentorsHelper = {} 
local version = 6
local sin = math.sin
local cos =  math.cos
local rad = math.rad


	local Aug = {
	[1] = Vector3.New(1268.16, -800.51, 830.32),
	[2] = Vector3.New(1227.63, -800.51, 900.47),
	[3] = Vector3.New(1308.60, -800.51, 900.56)
	}

	
	
	local colors = {}
	colors[1] ="ff00ff00"
	colors[2] ="ff00ff00"
	colors[3] ="ff00ff00"
	colors[4] ="ff00ff00"
	colors[5] ="ffffff80"
	colors[6] ="ffffff80"
	colors[7] ="ffffff80"
	

local LocalesNames = {
	["Organic Incinerator"] = {
		[1] = "Organic Incinerator",
		[2] = "Organic Incinerator",
		[3] = "Organic Incinerator",
		[99] = "Organic Incinerator",  --For Testing
	},
	["Prime Phage Distributor"] = {
		[1] = "Prime Phage Distributor",
		[2] = "Prime Phage Distributor",
		[3] = "Prime Phage Distributor",
		[99] = "Prime Phage Distributor",  --For Testing
	},
	["Prime Evolutionary Operant"] = {
		[1] = "Prime Evolutionary Operant",
		[2] = "Prime Evolutionary Operant",
		[3] = "Prime Evolutionary Operant",
		[99] = "Prime Evolutionary Operant",  --For Testing
	}
}

local zCoord = -800.60

local Coords = {}

	Coords[3] = {
	[1] = {
	["x"] = 1285.45,
	["z"] = 927.58
	},
	[2] = {
	["x"] = 1296.25,
	["z"] = 934.77
	},
	[3] = {
	["x"] = 1320.93,
	["z"] = 935.26,
	},
	[4] = {
	["x"] = 1332.09,
	["z"] = 928.45,
	},
	[5] = {
	["x"] = 1344.32,
	["z"] = 907.19,
	},
	[6] = {
	["x"] = 1344.04,
	["z"] = 891.89,
	},
	[7] = {
	["x"] = 1331.96,
	["z"] = 873.30,
	},
	[8] = {
	["x"] = 1321.60,
	["z"] = 866.36,
	},
	[9] = {
	["x"] = 1308.58,
	["z"] = 913.53,
	},
	[10] = {
	["x"] = 1319.61,
	["z"] = 907.28,
	},
	[11] = {
	["x"] = 1319.62,
	["z"] = 894.53,
	},
}

	Coords[1] = {
	[3] = {
	["x"] = 1291.21,
	["z"] = 803.33
	},
	[4] = {
	["x"] = 1280.26,
	["z"] = 796.33
	},
	[1] = {
	["x"] = 1302.87,
	["z"] = 837.23,
	},
	[2] = {
	["x"] = 1303.22,
	["z"] = 823.23,
	},
	[5] = {
	["x"] = 1256.22,
	["z"] = 796.51,
	},
	[6] = {
	["x"] = 1244.71,
	["z"] = 802.90,
	},
	[7] = {
	["x"] = 1232.53,
	["z"] = 823.87,
	},
	[8] = {
	["x"] = 1232.62,
	["z"] = 836.80,
	},
	[9] = {
	["x"] = 1278.79,
	["z"] = 823.45,
	},
	[10] = {
	["x"] = 1268.00,
	["z"] = 817.31,
	},
	[11] = {
	["x"] = 1256.95,
	["z"] = 823.64,
	},	
}

Coords[2] = {
	[1] = {
	["x"] = 1215.35,
	["z"] = 866.08,
	},
	[2] = {
	["x"] = 1204.24,
	["z"] = 872.99,
	},
	[3] = {
	["x"] = 1191.91,
	["z"] = 893.94
	},
	[4] = {
	["x"] = 1191.86,
	["z"] = 906.97
	},
	[5] = {
	["x"] = 1204.29,
	["z"] = 927.76,
	},
	[6] = {
	["x"] = 1215.66,
	["z"] = 934.04,
	},
	[7] = {
	["x"] = 1239.53,
	["z"] = 933.933,
	},
	[8] = {
	["x"] = 1250.87,
	["z"] = 927.76,
	},
	[9] = {
	["x"] = 1216.43,
	["z"] = 894.04,
	},
	[10] = {
	["x"] = 1216.33,
	["z"] = 906.61,
	},
	[11] = {
	["x"] = 1227.33,
	["z"] = 912.87,
	},
	
}



----------------------------------------------------------------------------------------------
-- Constants
-----------------------------------------------------------------------------------------------
-- e.g. local kiExampleVariableMax = 999
 
-----------------------------------------------------------------------------------------------
-- Initialization
-----------------------------------------------------------------------------------------------
function AugmentorsHelper:new(o)
    o = o or {}
    setmetatable(o, self)
    self.__index = self 

    -- initialize variables here

    return o
end

function AugmentorsHelper:Init()
	local bHasConfigureFunction = false
	local strConfigureButtonText = ""
	local tDependencies = {
		-- "UnitOrPackageName",
	}
    Apollo.RegisterAddon(self, bHasConfigureFunction, strConfigureButtonText, tDependencies)
end
 

-----------------------------------------------------------------------------------------------
-- AugmentorsHelper OnLoad
-----------------------------------------------------------------------------------------------
function AugmentorsHelper:OnLoad()
    -- load our form file
	self.xmlDoc = XmlDoc.CreateFromFile("AugmentorsHelper.xml")
	Apollo.LoadSprites("AHSprite.xml","AHSprite")
	self.xmlDoc:RegisterCallback("OnDocLoaded", self)
end

-----------------------------------------------------------------------------------------------
-- AugmentorsHelper OnDocLoaded
-----------------------------------------------------------------------------------------------
function AugmentorsHelper:OnDocLoaded()

	if self.xmlDoc ~= nil and self.xmlDoc:IsLoaded() then
	    self.Overlay = Apollo.LoadForm(self.xmlDoc, "Overlay", "InWorldHudStratum", self)
	    self.PopUp = Apollo.LoadForm(self.xmlDoc, "AHPopUp", nil, self)
		if self.Overlay == nil then
		Print("Error")
			Apollo.AddAddonErrorText(self, "Could not load the main window for some reason.")
			return
		end
	    self.PopUp:Show(false, true)
	    self.Overlay:Show(true)
		
		self.debug = false
		
		Apollo.RegisterEventHandler("UnitEnteredCombat", "OnEnteredCombat", self)
		if self.debug then
			Apollo.RegisterEventHandler("NextFrame", "OnNextFrame", self)
		end
    	Apollo.RegisterSlashCommand("auhelper", "OnOptions", self)
		Apollo.RegisterEventHandler("UnitCreated", "OnUnitCreated", self)
		--Apollo.RegisterEventHandler("InterfaceMenuListHasLoaded", "OnInterfaceMenuListHasLoaded", self)
--		Apollo.RegisterEventHandler("InterfaceClick", "OnInterfaceClick", self)

		self.lineWidth = 4
		self.lineLength = 32

		if self.bShowDigitize == nil then
			self.bShowDigitize = true
		end
		if self.bOrganicLine == nil then
			self.bOrganicLine = true
		end
		if self.KSlider == nil then
			self.KSlider = 2
		end
		
		self.OptionsButton = self.PopUp:FindChild("OptionsButton")
		self.OptionsPopUp = self.PopUp:FindChild("OptionsWindow")
		self.OptionsButton:AttachWindow(self.OptionsPopUp)
		
		self.watchList = {}
		

		
		self:FillOptionsWindow()
		self:OnSettingChange()
		self.Resolution = 5
		-- Locale Check
		local strCancel = Apollo.GetString(1)
		if strCancel == "Abbrechen" then
			self.Locale = 2
		elseif strCancel == "Annuler" then
			self.Locale = 3
		else
			self.Locale = 1
		end

		self.player = GameLib.GetPlayerUnit()
		if self.debug then  self:CheckWatchList(self.player) end
	end
end

function AugmentorsHelper:OnInterfaceMenuListHasLoaded()
		Event_FireGenericEvent("InterfaceMenuList_NewAddOn", "AugmentorsHelper", {"InterfaceClick", "", ""})
end

function AugmentorsHelper:OnInterfaceClick()
	self:OnOptions()
end



-----------------------------------------------------------------------------------------------
-- AugmentorsHelperForm Functions
-----------------------------------------------------------------------------------------------


-- when the OK button is clicked
function AugmentorsHelper:OnOK()
	self.PopUp:Close() -- hide the window
	self.OptionsButton:SetCheck(false)
end

-- when the Cancel button is clicked
function AugmentorsHelper:OnCancel()
	self.PopUp:Close() -- hide the window
	self.OptionsButton:SetCheck(false)
end


function AugmentorsHelper:OnOptions()
	if not self.PopUp:IsVisible() then
		self.PopUp:Invoke()
	else
		self:OnCancel()
	end

end
---------------------------------------------------------------------------------------------------
-- AHPopUp Functions
---------------------------------------------------------------------------------------------------

function AugmentorsHelper:OnSettingChange( wndHandler, wndControl, eMouseButton )
	self.bOrganicLine = self.PopUp:FindChild("bOrganicLine"):IsChecked()
	self.bShowDigitize = self.PopUp:FindChild("bShowDigitize"):IsChecked()
	self.KSlider = self.PopUp:FindChild("KSliderBar"):GetValue()
	
	self.PopUp:FindChild("SliderValue"):SetText(self.KSlider)
end


function AugmentorsHelper:ClearMarks( wndHandler, wndControl, eMouseButton )
	self:OnSettingChange()

end

function AugmentorsHelper:OnOptionsBtn( wndHandler, wndControl, eMouseButton )
end

-----------------------------------------------------------------------------------------------
-- AugmentorsHelper Instance
-----------------------------------------------------------------------------------------------
local AugmentorsHelperInst = AugmentorsHelper:new()
AugmentorsHelperInst:Init()


function AugmentorsHelper:OnNextFrame()
	if self.player == nil then
		self.player = GameLib.GetPlayerUnit()
	end	

	if self.player == nil then return end
	
	self.Overlay:DestroyAllPixies()

	if not self.debug and not self.player:IsInCombat() then
	  	Apollo.RemoveEventHandler("NextFrame",self)
		self.watchList = nil 
		self.watchList = {}
		return
	end
	
	local currentlist = self.watchList
	self.watchList = {}
	
	for k, v in pairs(currentlist) do
	local Vname = v:GetName()
--		self:SetupLines(v,false)
	
		if v:IsValid() then
			self.watchList[k]=v
		end
		if v:IsValid() and Vname == self:GetLocaleName("Organic Incinerator") then
			if self.bOrganicLine then
				self:DrawPixieLine(v,80,"e600000ff",self.KSlider+5)
			end
		end
	end	
	if self.bShowDigitize then
		self:DrawZoneLines()	
	end
end


function AugmentorsHelper:DrawPixieLine(v,dist,color,thick)
	if color == nil then
		color = "e60ff0000"
	end
	if thick == nil then
		thick = 10
	end
	
	local tface = v:GetFacing()
	if tface == nil then return end
	
	local tangle = math.atan2(tface.x, tface.z)
	local tpos = v:GetPosition()
	local tposV = Vector3.New(tpos.x,tpos.y,tpos.z)
	local dist = 100
	self:SimpleLine(tposV,dist,tangle + rad(0),thick,color)
end


function  AugmentorsHelper:DrawPixie(v)
	local vpos = v:GetPosition()
	local newPos = Vector3.New(vpos.x,vpos.y,vpos.z)
	local pos = GameLib.WorldLocToScreenPoint(newPos)

	local size = 20
	
	self.Overlay:AddPixie( {
	strText ="", strSprite = "CRB_GuildSprites:sprGuild_ZombieHand_Stretchable", cr = "ffff0000",
	loc = {fPoints = pixieLocPoints, nOffsets = {pos.x-size ,pos.y-size, pos.x+size, pos.y+size  } }
      } )

end

function AugmentorsHelper:DrawHelpers()
end

--- Knockback assist starter
function AugmentorsHelper:OnEnteredCombat(unit, bInCombat)
	--if GetCurrentZoneName() ~= "Genetic Archives - Act 2" then return end
	if unit and unit:GetType() ~= "NonPlayer" then return end
	local uName = unit:GetName()
	if uName == self:GetLocaleName("Organic Incinerator") or  uName == self:GetLocaleName("Prime Phage Distributor")then
	  	Apollo.RemoveEventHandler("NextFrame",self)
		Apollo.RegisterEventHandler("NextFrame", "OnNextFrame", self)
		self:CheckWatchList(unit)
	end
end

function AugmentorsHelper:OnUnitCreated(unit)
	if unit and unit:GetType() ~= "NonPlayer" then return end
	local uName = unit:GetName()
	if uName == "Prime Phage Distributor" then
	end

	if uName == self:GetLocaleName("Organic Incinerator") then
		self:CheckWatchList(unit)
	end

end

function AugmentorsHelper:GetLocaleName(name)
--	self.Locale = 99 -- For Testing
	if LocalesNames[name] ~= nil then
		return LocalesNames[name][self.Locale]
	end
	return false
end


function AugmentorsHelper:CheckWatchList(unit)
	if not self.watchList[unit:GetId()] then
		self.watchList[unit:GetId()] = unit
	end
end


function AugmentorsHelper:OnSave(eLevel)
	if eLevel ~= GameLib.CodeEnumAddonSaveLevel.Character then return end
	local tsave = {}
	tsave.KSlider = self.KSlider
	tsave.bShowDigitize = self.bShowDigitize
	tsave.bOrganicLine = self.bOrganicLine
	return tsave
end


function AugmentorsHelper:OnRestore(eLevel, saveData)
	if eLevel ~= GameLib.CodeEnumAddonSaveLevel.Character then return end
	for k,v in pairs(saveData) do
	   	self[k]=v
	end
end


function AugmentorsHelper:FillOptionsWindow()
	self.PopUp:FindChild("KSliderBar"):SetValue(self.KSlider or 2)
	self.PopUp:FindChild("SliderValue"):SetText(self.KSlider or 2)
	self.PopUp:FindChild("bOrganicLine"):SetCheck(self.bOrganicLine)
	self.PopUp:FindChild("bShowDigitize"):SetCheck(self.bShowDigitize)
end



function AugmentorsHelper:SimpleLine(tposV,dist,vect,sizeMod,color,noOffset)
	local End = Vector3.New(tposV.x+dist*sin(vect), tposV.y, tposV.z+dist*cos(vect))
	local Offset
	
	if not noOffset then
		Offset = Vector3.InterpolateLinear(End, tposV, 0.90)
	else
		Offset = tposV
	end
	
	self:DrawLine(End, Offset, color,sizeMod)
	return End
end


--Line Drawing
function AugmentorsHelper:DrawLine(startV, endV, col, sizeMod)
	local startPoint = GameLib.WorldLocToScreenPoint(startV)
	local endPoint = GameLib.WorldLocToScreenPoint(endV)
	self.Overlay:AddPixie( { bLine = true, fWidth = sizeMod or 2, cr = col, loc = { fPoints = { 0, 0, 0, 0 }, nOffsets = { startPoint.x, startPoint.y, endPoint.x, endPoint.y } } })
end


function AugmentorsHelper:OnOptionsBtn( wndHandler, wndControl, eMouseButton )
	 local OptionWindow = self.PopUp:FindChild("OptionsWindow")
	 OptionWindow:Show(not OptionWindow:IsShown())
end

function AugmentorsHelper:DrawZoneLines()
-- Decide which is the closest augmentor
	local ppos = self.player:GetPosition()
	local pvec = Vector3.New(ppos.x,ppos.y,ppos.z)
	local dist = 999
	local aug = 1
	for i =1,3 do
		local len = ((Aug[i] - pvec):Length())
		if len < dist then
			aug = i
			dist = len
		end	
	end	
	--if GameLib.WorldLocToScreenPoint(Aug[aug]).bOnScreen then

		self:DrawLine(Vector3.New(Coords[aug][1].x,-800.60,Coords[aug][1].z), Vector3.New(Coords[aug][8].x,-800.60,Coords[aug][8].z), "ffff0000", self.KSlider)
		local pos2 = Vector3.New(Coords[aug][2].x,-800.60,Coords[aug][2].z)
		local pos7 = Vector3.New(Coords[aug][7].x,-800.60,Coords[aug][7].z)
		local pos4 = Vector3.New(Coords[aug][4].x,-800.60,Coords[aug][4].z)
		
		local Offset = Coords[aug][9]
		self:DrawLine(Vector3.New(pos2.x,-800.60,pos2.z), Vector3.New(Offset.x,-800.60,Offset.z), "ff0000ff", self.KSlider)

		--back line 1
		self:DrawLine(Vector3.New(Coords[aug][3].x,-800.60,Coords[aug][3].z), Vector3.New(Offset.x,-800.60,Offset.z), "ff0000ff", self.KSlider)
		
		local Offset = Coords[aug][11]
		self:DrawLine(Vector3.New(pos7.x,-800.60,pos7.z), Vector3.New(Offset.x,-800.60,Offset.z), "ff00ff00", self.KSlider)
		
		--back line 4
		self:DrawLine(Vector3.New(Coords[aug][6].x,-800.60,Coords[aug][6].z), Vector3.New(Offset.x,-800.60,Offset.z), "ff00ff00", self.KSlider)
		
		local Offset = Coords[aug][10]
		self:DrawLine(Vector3.New(Coords[aug][4].x,-800.60,Coords[aug][4].z), Vector3.New(Offset.x,-800.60,Offset.z), "ffff8000", self.KSlider)
		
		local Offset = Coords[aug][10]

		self:DrawLine(Vector3.New(Coords[aug][5].x,-800.60,Coords[aug][5].z), Vector3.New(Offset.x,-800.60,Offset.z), "ffff8000", self.KSlider)
		
	--end
end


